<template>
  <div>
    <v-layout row wrap>
      <v-flex>
        <v-tabs>
          <v-tab @click="changeAreaTab('site')">Site</v-tab>
          <v-tab @click="changeAreaTab('coords')">Coordonnées</v-tab>
          <v-tab @click="changeAreaTab('caddie')">Caddie</v-tab>
        </v-tabs>
      </v-flex>
    </v-layout>

    <!-- modal loader -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogLoader" persistent max-width="400">
        <v-progress-linear :indeterminate="true"></v-progress-linear>
      </v-dialog>
    </v-layout>

    <v-layout v-if="area == 'site'" row wrap>
      <ui-table
        :initialConfig="initialConfig"
        :configInject="dataConfigSite"
        :configName="'site'"
        :initConfig="toInit"
      ></ui-table>
    </v-layout>
    <v-layout v-if="area == 'coords'" row wrap>
      <ui-table
        :initialConfig="initialConfig"
        :configInject="dataConfigCoords"
        :configName="'coords'"
        :initConfig="toInit"
      ></ui-table>
    </v-layout>
    <v-layout v-if="area == 'caddie'" row wrap>
      <ui-table
        :initialConfig="initialConfig"
        :configInject="dataConfigCaddie"
        :configName="'caddie'"
        :initConfig="toInit"
      ></ui-table>
    </v-layout>
  </div>
</template>
<script>
// import axios from "axios";
import { getHeader } from "@/config";
import configSiteJson from "@/config-data/config-site.json";
import configCoordsJson from "@/config-data/config-coords.json";
import configCaddieJson from "@/config-data/config-caddie.json";
import uiTable from "./_table.vue";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_FETCH_DATA_CONFIG_SITE = URL_API + "api/config/config-from-name/";
const URL_CREATE_CONFIG = URL_API + "api/config/create/";

export default {
  components: {
    "ui-table": uiTable
  },
  mounted: function() {
    this.fetchConfig();
    // this.fetchAllDataConfig();
    // this.fetchDataConfig(this.area);
  },
  data() {
    return {
      // misc
      dialogLoader: false,
      labelValidConfig: "",
      toInit: true,

      // config
      configSiteJson,
      configCoordsJson,
      configCaddieJson,
      dataConfigSite: [],
      dataConfigCoords: [],
      dataConfigCaddie: [],
      area: "site",
      initialConfig: []
    };
  },
  methods: {
    fetchConfig() {
      this.configSiteJson.configSite.forEach(el => {
        this.dataConfigSite.push(el);
      });
      this.configCoordsJson.configCoords.forEach(el => {
        this.dataConfigCoords.push(el);
      });
      this.configCaddieJson.configCaddie.forEach(el => {
        this.dataConfigCaddie.push(el);
      });
      this.initialConfig["site"] = this.dataConfigSite;
      this.initialConfig["coords"] = this.dataConfigCoords;
      this.initialConfig["caddie"] = this.dataConfigCaddie;

      this.fetchAllDataConfig();
    },
    initializeConfig(index) {
      const listeConfig = ["site", "coords", "caddie"];
      let payload = {
        data: this.initialConfig[listeConfig[index]]
      };
      let urlAction = URL_CREATE_CONFIG + listeConfig[index];
      this.$axios
        .post(urlAction, payload, { headers: getHeader() })
        .then(response => {})
        .catch(error => {
          console.log("error", error);
        });
    },
    changeAreaTab(newZone) {
      this.area = newZone;
      // this.fetchDataConfig(newZone);
    },

    fetchAllDataConfig() {
      const requestOne = this.$axios.get(URL_FETCH_DATA_CONFIG_SITE + "site", { headers: getHeader() });
      const requestTwo = this.$axios.get(URL_FETCH_DATA_CONFIG_SITE + "coords", { headers: getHeader() });
      const requestThree = this.$axios.get(URL_FETCH_DATA_CONFIG_SITE + "caddie", { headers: getHeader() });
      this.$axios
        .all([requestOne, requestTwo, requestThree])
        .then(
          this.$axios.spread((...responses) => {
            const responseOne = responses[0];
            const responseTwo = responses[1];
            const responesThree = responses[2];

            responses.forEach((resp, i) => {
              if (resp.data.config == null) {
                this.initializeConfig(i);
              } else {
                let selectedConfig = JSON.parse(resp.data.config.data);
                switch (i) {
                  case 0:
                    this.dataConfigSite = selectedConfig;
                    break;
                  case 1:
                    this.dataConfigCoords = selectedConfig;
                    break;
                  case 2:
                    this.dataConfigCaddie = selectedConfig;
                    break;
                  default:
                    break;
                }
              }

              // console.log("data", resp.data.config);
            });
          })
        )
        .catch(errors => {
          console.log("errors", errors);
        });
    },
    fetchDataConfig(name) {
      this.dialogLoader = true;
      this.$axios
        .get(URL_FETCH_DATA_CONFIG_SITE + name, { headers: getHeader() })
        .then(response => {
          if (response.data.config !== null) {
            let selectedConfig = JSON.parse(response.data.config.data);
            switch (name) {
              case "site":
                this.dataConfigSite = selectedConfig;
                break;
              case "coords":
                this.dataConfigCoords = selectedConfig;
                break;
              case "caddie":
                this.dataConfigCaddie = selectedConfig;
                break;
              default:
                break;
            }
          }
          this.dialogLoader = false;
        })
        .catch(error => {
          console.log("error", error);
          this.dialogLoader = false;
        });
    }
  }
};
</script>
